//Clase LISTA (con punto de interes)
//lista doblemente enlazada circular con nodo cabeza
//Implementacion
//Autor: Jesus Albert (20 de abril)
////////////////////////////////////////////////////////
#include "lista2cabeza.h"
#include <iostream>

using namespace std;

Lista::Lista ()
{
    cabeza = new Nodo;
    cabeza->sig = cabeza;
    cabeza->ant = cabeza;
    pto = cabeza;
}

Lista::Lista (const Lista& orig)
{
   cabeza = new Nodo;
   cabeza->sig = cabeza;
   cabeza->ant = cabeza;

   if (! Copiar (orig))
       cerr << "Lista: Error en el constructor de copia" << endl;    
}

Lista::~Lista ()
{
   Vaciar();
   delete cabeza;
}

const Lista& Lista::operator= (const Lista& orig)
{
    Vaciar();
    if (! Copiar (orig))
       cerr << "Lista: Error en la asignacion" << endl;
    return (*this);
}

bool Lista::Insertar ( Valor x )
{
    Puntero aux;
    bool ok;

    aux = new Nodo;
    if ( aux == NULL )
       ok = false;
    else
    {
       ok = true;
       aux->info = x;
       aux->sig = pto;
       aux->ant = pto->ant;
       pto->ant->sig = aux;
       pto->ant = aux;
    }
    return (ok);
}

bool Lista::Eliminar ()
{
    Puntero aux;
    bool ok;

    if (pto == cabeza)
        ok = false;
    else
    {
        ok = true;
        aux =  pto;
        pto->sig->ant = pto->ant;
        pto->ant->sig = pto->sig;
        pto = pto->sig;
        delete aux;
    }
    return (ok);
}

bool Lista::Consultar (Valor& x)
{
    bool ok;

    if (pto == cabeza)
        ok = false;
    else
    {
        ok = true;
        x = pto->info;
    }
    return (ok);
}

bool Lista::ListaVacia ()
{
    return ( cabeza->sig == cabeza );
}

void Lista::IrInicio()
{
    pto = cabeza->sig;
}

void Lista::IrUltimo()
{
    pto = cabeza->ant;
}

bool Lista::Avanzar()
{
    bool ok;

    if ( pto == cabeza )
        ok = false;
    else
    {
        ok = true;
        pto = pto->sig;
    }
}

bool Lista::Retroceder()
{
    bool ok;

    if ( pto == cabeza->sig )
        ok = false;
    else
    {
        ok = true;
        pto = pto->ant;
    }
}

bool Lista::FinalLista()
{
    return ( pto == cabeza );
}

bool Lista::Copiar (const Lista& orig)
{
    Puntero aux, dup;
    bool ok=true;

    //El nodo cabeza de this ya existe,
    //no se vuelve a crear
    aux = orig.cabeza->sig;

    while ( aux != orig.cabeza )
    {
        dup = new Nodo;
        if (dup==NULL)
           ok =false;
        else
        {
           dup->info = aux->info;
           dup->sig = cabeza;
           dup->ant = cabeza->ant;
           cabeza->ant->sig = dup;
           cabeza->ant = dup;

           if ( aux == orig.pto ) //fijar pto. de interes
              pto = dup;
           aux = aux->sig;
        }
    }
    return (ok);
}

void Lista::Vaciar ()
{
   IrInicio();
   while ( Eliminar() );
}
