//Clase LISTA (con punto de interes)
//Lista doblemente enlazada circular con nodo cabeza
//Interfaz
//Autor: Jesus Albert (20 de abril)
////////////////////////////////////////////////////////
#include <string>

#ifndef _LISTA_DOBLE_H_
#define _LISTA_DOBLE_H_
using namespace std;
//Declaracion del tipo base de la lista
//Si el tipo base cambia es preciso modificar esta linea
//Declaracion del tipo base de la lista
struct Valor
{
    string pregunta;
    string resA;
    string resB;
    string resC;
    char correcta;
    int nivel; //nivel de dificultad 1.-poca ... 5.-mucha
    int veces;
    int ID;   // Identificador nico de pregunta
};

class Lista
{
    public:
        //constructores y destructor
        Lista ();
        Lista (const Lista&);
        ~Lista();
        const Lista& operator= (const Lista&);

        //Operaciones con datos:
        //Insertar (Valor): Inserta el Valor delante del pto de interes
        //devuelve false si no hay memoria suficiente
        bool Insertar (Valor);
        //Eliminar(): Elimina el Valor del pto de interes
        //devuelve false si el pto de interes esta mas alla del ultimo elemento
        bool Eliminar ();
        //Consultar (Valor&): Recupera el Valor del pto de interes
        //y lo almacena en el argumento por referencia
        //devuelve false si el pto de interes esta mas alla del ultimo elemento
        bool Consultar (Valor&);
        //ListaVacia(): Indica si la lista no tiene elementos
        //devuelve true si la lista esta vacia
        bool ListaVacia();

        //Operaciones con el pto. de interes:
        //IrInicio(): Desplaza el pto. de interes al primer elemento
        //de la lista
        void IrInicio();
        //IrUltimo(): Desplaza el pto. de interes al ultimo elemento
        //de la lista
        void IrUltimo();
        //Avanzar(): Desplaza el pto. de interes al siguiente elemento
        //de la lista. Es posible ir una posicion mas alla del ultimo
        //Devuelve false si el pto. de interes esta detras del ultimo elemento
        //y no es posible seguir avanzando
        bool Avanzar();
        //Retroceder(): Desplaza el pto. de interes al anterior elemento
        //de la lista. No es posible retroceder mas atras del primer elemento
        //Devuelve false si el pto. de interes esta en el primer elemento
        bool Retroceder ();
        //FinalLista(): Indica si el pto. de interes ha sobrepasado
        //la posicion del ultimo elemento de la lista y devuelve true
        //en ese caso.
        bool FinalLista();

    private: //lista doblemente enlazada circular con nodo cabeza
        struct Nodo;
        typedef Nodo* Puntero;
        struct Nodo
        {
            Valor info;
            Puntero sig;
            Puntero ant;
        };

        Puntero cabeza;
        Puntero pto;

        bool Copiar (const Lista&);
        void Vaciar ();
};
#endif
